#!/usr/bin/perl -w
# /usr/local/httpd/cgi-bin/internet.cgi
# Autor: Dr. Dieter Heimann, Robert-Bosch-Berufskolleg, Dortmund
# letzte Aenderung: 23. Februar 2000
#
# Auswertung des Formulars /cgi-bin/formzugang.cgi
# Sperren des Internetzugang ausgewaehlter Rechner
#
use CGI qw(:standard);
#
# Beginn Standardkonfiguration
$server_ip = "192.168.1.21";
$server_port = "3128";

# Auswahl des Verfahrens: Kernelversionen 2.0 und 2.2 fr Firewall moeglich
# 1.0 waehlt den Proxy
$kernelver="1.0";
 
# Datei mit den Arbeitsplaetzen
$plaetze="/etc/httpd/ipfw_http";
 
# Steuerdatei von Squid
$squidfile="/etc/squid.sperren_ip";                                              

# Kommandozeile fuer Squid
$cmdsquid = "sudo /usr/sbin/squid -k reconfigure";

# Log-Datei der Sperrungen
$logfile="log/ipfw_http";

# Lock-Datei
$lockfile="log/internet.log";

# Hintergrund des Formulars
$background="";
$cgipath="/cgi-bin/";

# gesperrte User
$denyuser="/etc/httpd/htpasswd.user.gesperrt";

# Ausgabe der letzten Aufrufe durch den User
$printlog="ja";

# Ende Standardkonfiguration

# Konfigurationsdatei, falls vorhanden auswerten
sub get_param
# Zeichenkette zwischen " " auswaehlen
{
 $temp = substr($_[0],index($_[0],"\"")+1);
 $temp = substr($temp,0,index($temp,"\""));
 return $temp;
}
if (open(CONF,"/etc/zugang.conf"))
{
 while (<CONF>)
 {
# alle Kommentarzeilen nicht bearbeiten
  unless (/^#/)
  {
   if (/kernelver/) { $kernelver = &get_param($_) }
   if (/server_ip/) { $server_ip = &get_param($_) }
   if (/server_port/) { $server_port = &get_param($_) }
   if (/plaetze/)   { $plaetze = &get_param($_) }
   if (/squidfile/) { $squidfile = &get_param($_) }
   if (/logfile/)   { $logfile = &get_param($_) }
   if (/background/) { $background = &get_param($_) }
   if (/cgipath/)   { $cgipath = &get_param($_) }
   if (/cmdsquid/)  { $cmdsquid = &get_param($_) }
   if (/denyuser/)  { $denyuser = &get_param($_) }
   if (/printlog/)  { $printlog = &get_param($_) }
  }
 }
}
# Konfigurationsdatei ausgewertet

# eigentliches Skript
$user = $ENV{REMOTE_USER};
$kontrolle = param("kontrolle");
head_page();
if ($kontrolle ne "zugang")
{
print "Diese Skript kann nur durch das Formular aufgerufen werden!";
sub_tail();
exit 0
}

# gesperrte User bestimmen
if (open (SPERR,"$denyuser"))
{
 while (<SPERR>)
 {
  unless (/^#/)
  {
   if (/^$user/)
   {
    print "Sehr geehrte Kollegin, sehr geehrter Kollege, <BR><BR>";
    print "bitte melden Sie sich bei Herrn Dr. Heimann zur Eingabe eines neuen Passwortes! <BR>";
    tail_page();
    exit 0
   }
  }
 }
}
# weiter, wenn user nicht gesperrt
print "Die folgenden Zugangsberechtigungen wurden von <strong>$user</strong>";
print " gendert!<BR>\n";

# aktuelle Konfiguration bestimmen
$path = $ENV{'PATH'};       # $path now tainted           

$ENV{'PATH'} = '/bin:/usr/bin';
delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};
 
$path = $ENV{'PATH'};       # $path now NOT tainted
if ($kernelver eq "2.2")
{
   @status = `log/ipchains -L input -n`;
}
elsif ($kernelver eq "2.0")
{
  @status = `log/ipfwadm -I -l -n | grep $server_port`;
}
else
{
  open (INFILE, "<$squidfile") || print "Kann die Datei $squidfile nicht ffnen!<BR>";
  @status = <INFILE>;
  close (INFILE);
} 
$zeilen = @status;
# nur eine aktive Instanz des Skrits
while (system("test -f $lockfile") == 0)
{ sleep (1); }
system("touch $lockfile");

# definierte Raeume und Arbeitsplatze auslesen
open (INFILE, "<$plaetze") || print "Kann die Datei $plaetze nicht oeffen!<BR>";
@adressen = <INFILE>;
close (INFILE);
$anzahl = @adressen;

open (LOGFILE, ">>$logfile");
$datum = localtime(time());
print LOGFILE "$datum - $user\n";

for ($i=0; $i<$anzahl; $i++)
{
   $adr = substr($adressen[$i],0,length($adressen[$i])-1);
   if ($adr !~ /^#/)
    {
     if ($adr =~ /^Raum/)
      {
         $raumname = $adr;
#        print "<H3>$adr</H3>\n";
      }
     else
      {
       $pc = substr($adr,0,index($adr," "));
       $pc_ = $pc;
       $pc =~ s/-/_/g;
       $ip = substr($adr,index($adr," ")+1);
       $k = 0;
       if (param($pc))
        {
         $ipnew = param($pc);
        }
       else
        {
         $ipnew = "";
        }
       if (open (INFILE, "<log/$ip"))
       {
         while (<INFILE>)
         {
           $anmeldung = $_;
         }
         close(INFILE);
       }
       else
       {
        $anmeldung = "";
       }  
       $aendern=$ipnew;
#       print "$pc - $aendern \n";
       if ($aendern ne "no_change")
       {
         $gesperrt = "ja";
         while ($k < $zeilen)
         {
          if ($status[$k] =~ /$ip(\s|\/)/s)
           {
            $gesperrt = "nein";
            $index = $k;
            $k = $zeilen;
           }
           $k++;
         }
         if (($ipnew eq "") && ($gesperrt eq "ja"))
          {
           if ($kernelver eq "2.2")
            {
            system("log/ipchains -I input -j ACCEPT -p tcp -s $ip -d $server_ip $server_port");
            }
           elsif ($kernelver eq "2.0")
            {   
	   system("log/ipfwadm -I -i accept -P tcp -S $ip -D $server_ip $server_port");
            }
           else
            {
            $temp="$ip/255.255.255.255";
            push(@status,$temp);
            }
           print "$raumname <font color=\"#008000\">$pc_ ($ip) $anmeldung freigegeben </font><BR>\n";
           print LOGFILE "$pc_ ($ip) $anmeldung wieder freigegeben \n";
          }
         if (($ipnew ne "") && ($gesperrt eq "nein"))
          {
          if ($kernelver eq "2.2")
           {
           system("log/ipchains -D input -j ACCEPT -p tcp -s $ip -d $server_ip $server_port"); 
           }
          elsif ($kernelver eq "2.0")
           {
	   system ("log/ipfwadm -I -d accept -P tcp -S $ip -D $server_ip $server_port");
           }
           else
           {
           $temp="";
           $status[$index] = $temp;
           }
           print "$raumname <font color=\"#FF0000\">$pc_ ($ip) $anmeldung gesperrt </FONT><BR>\n";
           print LOGFILE "$pc_ ($ip) $anmeldung gesperrt\n";
          }
        }
      }
    }
}
close(LOGFILE);
# evtl. Squid-Konfiguration neu eintragen und einlesen
if ($kernelver eq "1.0")
{
 open (INFILE, ">$squidfile") || print "<font color=\"#FF0000\">Fehler beim Schreiben in $squidfile!</font><BR>";
@temp = sort(@status);
for(@temp)
 {
   if (/255/)
   {
    if (/[\n]/)
    { print INFILE $_; }
    else
    { print INFILE $_,"\n"; }
   }
 }
 close(INFILE);
 if (system($cmdsquid) == 0)
 {
   print "Proxyzugang gendert!<BR>";
 }
 else
 {
   print "<font color=\"#FF0000\">Fehler!</font> Proxyzugang nicht gendert!<BR>";
 }
}
system("/bin/rm $lockfile");
$link = join($cgipath,"formzugang.cgi");
print <<Begin;
Um den aktuellen Status zu erhalten, mssen Sie das  
<a HREF="$link">Formular </a>
erneut aufrufen und aktualisieren!<BR>
Begin
if ($printlog eq "ja")
{
 print_log();
}
tail_page();
# Skriptende

sub tail_page
{
print <<Begin;
<HR><SMALL><SMALL>
<table border=\"0\" cellpadding=\"2\" width=\"100%\" 
<TR><TD>
<small><small>Autor: <a href="mailto:Dieter.Heimann\@T-Online.de">
Dr. Heimann</a> </small></small></TD>
<TD> <p align=\"right\"><small><small>
Mai 2001</small></small></p></TD>
</TABLE></SMALL></SMALL></BODY>
Begin
}
# Seitenkopf als Unterfunktion
sub head_page
{
print "Content-type: text/html \n\n";
print <<Begin;
<HTML><HEAD><TITLE>Sperrung des Internetzuganges</TITLE></HEAD>
<BODY background="$background" bgcolor="#CCCCCC" text="#000000" >
<CENTER><H2>Vernderung der Zugriffsrechte</H2>
</CENTER>\n
Begin
}

# Ausgabe der letzten Sperrungen
sub print_log
{
 if (open(LOGFILE,"$logfile"))
 {
  print <<Begin;
  <BR><HR><BR>
  <strong>Sehr geehrte Kollegin, sehr geehrter Kollege, </strong><BR><BR>
  bitte <strong>berprfen</strong> Sie, ob die folgenden Sperrungen von Ihnen durchgefhrt worden sind.
  <BR>Falls nicht, wenden Sie sich bitte zur nderung Ihres Passwortes an die AG Intranet.<BR><BR>
Begin
  while (<LOGFILE>)
  {
   if (/$user/)
   {
    print "$_<BR>";
   }
  }
 close (LOGFILE);
 }
}
